#Include "Totvs.ch"
#Include "Font.ch"
#Include "TBICONN.ch"
#Include "COLORS.ch"
#Include "RPTDEF.ch"
#Include "FWPrintSetup.ch"
#Include "TopConn.ch"
#Include 'Protheus.ch'

#Define IMP_SPOOL 2

//Variveis utilizadas no fonte inteiro

Static nEsquerda := 0 	//Alinhamento a Esquerda
Static nDireita  := 1 	//Alinhamento a Direita
Static nCenter   := 2 	//Alinhamento Centralizado

//==============================================================================================================================================================================================
User Function ORCAMENT()
//==============================================================================================================================================================================================
	Local nLastKey		:= 0
	Local nCount		:= 0  
	Local cPerg			:= "PERORC" 
	Local nLinha		:= 050  	// Controle de Linhas
	Local nColuna		:= 000 	// Indica a posio da primeira coluna  
	Private cOrc 	   	:= ""    
	Private cEmissao	:= ""
	Private nQtdPag		:= 0
	Private oPrint		:= Nil
	Private oFont1 		:= Nil
	Private oFont2  	:= Nil
	Private oFont3  	:= Nil
	Private oFont4  	:= Nil
	Private oFont5  	:= Nil
	Private oFont6  	:= Nil
	Private cHoraEx     := Time()
	Private nPagAtu     := 1
	Private nColIni     := 010
	Private nColFim		:= 2360
	Private nColunaBkp	:= nColuna		


	ValidPerg(cPerg)      
	If !(Pergunte(cPerg,.T.))
		Return Nil
	Endif  

	If lastKey() == 27 .or. nLastKey == 27 .or. nLastKey == 286
		Return Nil
	Endif

	// Instnciao do Objeto OPrint
	oPrint:= FWMSPrinter():New("ORCAMENT", IMP_SPOOL)
	oPrint:SetPortrait()
	oPrint:SetResolution(78)
	oPrint:SetPortrait()
	oPrint:SetPaperSize(DMPAPER_A4)
	oPrint:SetMargin(60,60,60,60)	

	oFont1 := TFontEx():New(oPrint, "Poppins", 14, 14, .T., .T., , , , , .F.)
	oFont2 := TFontEx():New(oPrint, "Poppins", 08, 08, .T., .F., , , , , .F.)
	oFont3 := TFontEx():New(oPrint, "Poppins", 10, 10, .T., .T., , , , , .F.)
	oFont4 := TFontEx():New(oPrint, "Poppins", 10, 14, .T., .T., , , , , .T.)
	oFont5 := TFontEx():New(oPrint, "Poppins", 10, 10, .T., .F., , , , , .F.)
	oFont6 := TFontEx():New(oPrint, "Poppins", 09, 09, , .F., , , , , .F.)
	oFont7 := TFontEx():New(oPrint, "Poppins", 10, 10, , .F., , , , , .F.)
	oFont8 := TFontEx():New(oPrint, "Arial", 08, 08, .F., .F., , , , , .F.)
	
	// Query que retorna os dados do orcamento e os dados dos itens.
	cQuery := " SELECT "
	cQuery += "		CJ_NUM, CJ_EMISSAO, CJ_CONDPAG, CJ_DESC1, CJ_DESC2, CJ_DESC3, CJ_FRETE, CJ_DESPESA, CJ_SEGURO, CJ_MOEDA, "
	cQuery += "		CJ_DESC4, CJ_DATA1, CJ_DATA2, CJ_DATA3, CJ_DATA4, CJ_PARC1, CJ_PARC2,CJ_COTCLI, CJ_ZZDIAEN, "
	cQuery += "		CJ_PARC3, CJ_PARC4, CJ_CLIENTE, CJ_LOJA, CJ_VALIDA, CJ_PROSPE, CJ_ZZTRANS,CJ_ZZVEND, CJ_ZZCONT, CJ_ZZEMAIL, CJ_ZZTEL, CJ_ZZREGIA, "
	cQuery += " 	ISNULL(CONVERT(VARCHAR(8000), CONVERT(BINARY(8000), CJ_ZZOBSOR)), '') AS CJ_ZZOBSOR,"
	cQuery += "		CASE  "
	cQuery += "			WHEN CJ_TPFRETE = 'C' THEN 'CIF' "
	cQuery += "			WHEN CJ_TPFRETE = 'F' THEN 'FOB' "
	cQuery += "			WHEN CJ_TPFRETE = 'T' THEN 'Por conta terceiros' "
	cQuery += "			WHEN CJ_TPFRETE = 'R' THEN 'Por conta remetente' "
	cQuery += "			WHEN CJ_TPFRETE = 'D' THEN 'Por conta destinatrio' "
	cQuery += "			WHEN CJ_TPFRETE = 'S' THEN 'Sem frete' "
	cQuery += "		END AS CJ_TPFRETE, "
	cQuery += "		CJ_TIPO, CJ_TIPOCLI, "
	cQuery += "		CJ_FRETE,E4_DESCRI, "
	cQuery += "		CK_ITEM, CK_NUM, CK_PRODUTO, CK_DESCRI, CK_UM, CK_TES, CK_ENTREG, CK_ZZVALID, CK_DESCONT, "
	cQuery += "		CK_QTDVEN, CK_PRCVEN, CK_VALOR,CK_OBS, B1_IPI, B1_POSIPI,B1_ALIQISS,"
	cQuery += "		CK_ZBASICM, CK_ZICM, CK_ZVALICM, CK_ZBASSOL, CK_ZICMSOL, CK_ZVALSOL, CK_ZBASIPI, CK_ZIPI, CK_ZVALIPI, CK_ZBASCOF, CK_ZCOF, CK_ZVALCOF, CK_ZBASPIS, CK_ZPIS, CK_ZVALPIS, CK_ZZNCM, "
	cQuery += " 	ISNULL(CONVERT(VARCHAR(8000), CONVERT(BINARY(8000), CK_ZZINFAD)), '') AS CK_ZZINFAD,"
	cQuery += " 	CK_ZBASICM, CK_ZICM, CK_ZVALICM, CK_ZBASSOL, CK_ZICMSOL, CK_ZVALSOL, CK_ZBASIPI,"
	cQuery += " 	CK_ZIPI, CK_ZVALIPI, CK_ZBASCOF, CK_ZCOF, CK_ZVALCOF, CK_ZBASPIS, CK_ZPIS, CK_ZVALPIS,"
	cQuery += "		A1_COD,	A1_NOME, A1_EMAIL, A1_END, A1_MUN, A1_DDD, A1_TEL, A1_EST, A1_CEP, A1_BAIRRO, A1_CONTATO, A1_HPAGE, A1_CGC, A1_INSCR, "
	cQuery += "		A3_NOME,A3_EMAIL,A3_TEL,"
	cQuery += "		A4_NOME, F4_IPI, F4_ICM,F4_ISS,	 "
	cQuery += "		US_COD, US_LOJA, US_NOME,US_CGC"
	cQuery += " FROM " + RetSqlName("SCJ") + " AS SCJ "
	cQuery += "		INNER JOIN " + RetSqlName("SCK") + " AS SCK ON "
	cQuery += "			CK_FILIAL = '" + xFilial("SCK")+ "' AND CJ_NUM = CK_NUM AND SCK.D_E_L_E_T_ = ' ' "
	cQuery += "		INNER JOIN " + RetSqlName("SA1") + " AS SA1 ON "
	cQuery += "				A1_FILIAL = '" + xFilial("SA1")+ "' AND CJ_CLIENTE = A1_COD AND CJ_LOJA = A1_LOJA AND SA1.D_E_L_E_T_ = ' ' "
	cQuery += "		LEFT JOIN " + RetSqlName("SUS") + " AS SUS ON "
	cQuery += "				US_FILIAL = '" + xFilial("SUS")+ "' AND CJ_PROSPE = US_COD AND CJ_LOJPRO = US_LOJA AND SUS.D_E_L_E_T_ = ' ' "
	cQuery += "		LEFT JOIN " + RetSqlName("SE4") + " AS SE4 ON "
	cQuery += "				E4_FILIAL = '" + xFilial("SE4")+ "' AND CJ_CONDPAG = E4_CODIGO AND SE4.D_E_L_E_T_ = ' ' "
	cQuery += "		LEFT JOIN " + RetSqlName("SB1") + " AS SB1 ON "
	cQuery += "				B1_FILIAL = '" + xFilial("SB1")+ "' AND CK_PRODUTO = B1_COD AND SB1.D_E_L_E_T_ = ' ' "
	cQuery += "		LEFT JOIN " + RetSqlName("SA3") + " AS SA3 ON "
	cQuery += "				A3_FILIAL = '" + xFilial("SA3")+ "' AND A3_COD = CJ_ZZVEND AND SA3.D_E_L_E_T_ = ' ' "
	cQuery += "		LEFT JOIN " + RetSqlName("SA4") + " AS SA4 ON "
	cQuery += "				A4_FILIAL = '" + xFilial("SA4")+ "' AND A4_COD = CJ_ZZTRANS AND SA4.D_E_L_E_T_ = ' ' "
	cQuery += "		LEFT JOIN " + RetSqlName("SF4") + " AS SF4 ON "
	cQuery += "				F4_FILIAL = '" + xFilial("SF4")+ "' AND F4_CODIGO = CK_TES AND SF4.D_E_L_E_T_ = ' ' "
	cQuery += " WHERE CJ_FILIAL = '" + xFilial("SCJ")+ "' AND SCJ.D_E_L_E_T_ = ' ' AND CJ_NUM >= '"+ mv_par01 +"' AND CJ_NUM <= '"+ mv_par02 +"' "
	
	If !Empty(mv_par03) .AND. !Empty(mv_par04)
		cQuery += " AND CJ_EMISSAO BETWEEN '" + DtoS(mv_par03) + "' AND '" + DtoS(mv_par04) + "' "
	EndIf
	
	cQuery += "ORDER BY CJ_NUM, CK_ITEM "
	TCQUERY cQuery NEW ALIAS "cAlias"
	Count to nCount      

	cAlias->(dbgotop()) 
	While cAlias->(!Eof()) 
	
		cOrc := cAlias->CJ_NUM		
		TCSETFIELD("cAlias","CJ_EMISSAO","D") 
		TCSETFIELD("cAlias","CJ_VALIDA","D") 
		TCSETFIELD("cAlias","CK_ENTREG","D") 
		cEmissao := cAlias->CJ_EMISSAO
		
		// Query que retorna a Quantidade Total de itens em um orcamento
		cQuery := "SELECT COUNT(CK_ITEM) AS Total "
		cQuery += " FROM " + RetSqlName("SCK")
		cQuery += " WHERE CK_NUM = '" + cAlias->CJ_NUM + "'"
		cQuery += " and D_E_L_E_T_ = ' ' "
		TCQUERY cQuery NEW ALIAS "cCount"
		
		nCount 	:= cCount->Total 
		nQtdPag := STR((cCount->Total / 30)+ 1) 
		nQtdPag := LEFT(nQtdPag, AT(".",nQtdPag)-1)
		cCount->(dbCloseArea())

		IMPCAB(@nLinha, @nColuna, cOrc, cEmissao)		// Funcao para impressao do Cabecalho
		IMPCLI(@nLinha, @nColuna)						// Funcao para impressao dos dados do Cliente
		IMPPRO(@nLinha, @nColuna, cOrc,nCount,nQtdPag)	// Funcao para impressao dos Detalhes do Produto  

		oPrint:EndPage()	
		cAlias->(dbSkip())			
	Enddo
	
	cAlias->(dbCloseArea())
	oPrint:Preview()	//Visualiza antes de imprimir

Return Nil

/*---------------------------------------------------------------------*
| Func.: IMPCAB                                                        |
| Desc.: Impressao do cabecalho do relatorio.	                       |
 *--------------------------------------------------------------------*/
//===============================================================================================================================================================================
Static Function IMPCAB(nLinha, nColuna, cOrc, cEmissao)
//===============================================================================================================================================================================
	Local cTexto		:= ""

	nLinha	:= 0050  	// Controle de Linhas
	nColuna	:= 1500 	// Indica a posio da primeira coluna 
	 						 

	dbSelectArea("SM0")
	SM0->(dbseek(cEmPant + cFilant))
	oPrint:StartPage()
	
	oPrint:SayBitmap(nLinha-50, nColIni,"\system\logo_orcamento.png", 700, 220)
	oPrint:Say(nLinha, nColuna, Upper(RTrim(SM0->M0_NOMECOM)),oFont1:oFont,100,,,nDireita)
	nLinha += 50

	cTexto := Upper(AllTrim(SM0->M0_ENDENT))
	oPrint:Say(nLinha, nColuna, Upper(cTexto),oFont5:oFont,100,,,nDireita)
	nLinha += 50

	cTexto := Upper(AllTrim(SM0->M0_CIDENT)) + "/" + Upper(AllTrim(SM0->M0_ESTENT)) + "   -   CEP: " + LEFT(AllTrim(SM0->M0_CEPENT),5) + "-" + RIGHT(AllTrim(SM0->M0_CEPENT),3)
	oPrint:Say(nLinha, nColuna, Upper(cTexto),oFont5:oFont,100,,,nDireita)
	nLinha += 50

	cTexto := "Fone: " + AllTrim(SM0->M0_TEL)
	oPrint:Say(nLinha, nColuna, cTexto,oFont5:oFont,100,,,nDireita)
	nLinha += 50

	cTexto := "CNPJ: " + AllTrim(Transform(SM0->M0_CGC, "@R 99.999.999/9999-99")) + " - IE: " +  AllTrim(Transform(SM0->M0_INSC, "@R 999.999.999.999"))
	cTexto := Upper(cTexto)
	oPrint:Say(nLinha, nColuna, cTexto,oFont5:oFont,100,,,nDireita)
	nLinha += 30

	oPrint:Line(nLinha, nColIni,nLinha, nColFim)
	nLinha += 57
	
	oPrint:Say(nLinha, 0050, "Oramento N " + cOrc		,oFont1:oFont,100)
	oPrint:Say(nLinha, 1800, "Data: " + DTOC(cEmissao)	,oFont1:oFont,100)
	nLinha += 45
	
	oPrint:Line(nLinha, 0010,nLinha, nColFim)


	nLinha += 50

Return Nil

/*---------------------------------------------------------------------*
| Func.: IMPCLI                                                        |
| Desc.: Impressao dos Dados do Cliente.                               |
 *--------------------------------------------------------------------*/
//===============================================================================================================================================================================
Static Function IMPCLI(nLinha, nColuna)
//===============================================================================================================================================================================
	Local cDescReg	:= Alltrim(POSICIONE("SX5",1,XFILIAL("SX5")+"A2"+cAlias->CJ_ZZREGIA,"X5_DESCRI"))

	nColuna := 50	

	oPrint:Say(nLinha, nColuna, "Cliente" 												,oFont3:oFont,100)
	oPrint:Say(nLinha, nColuna + 0190, ": " + cAlias->A1_COD + " - " + cAlias->A1_NOME	,oFont5:oFont,100)
	oPrint:Say(nLinha,1500, "Prazo de Fabricao"						,oFont3:oFont,100)
	If cAlias->CJ_ZZDIAEN == 0
		oPrint:Say(nLinha, 1800,": A COMBINAR",oFont5:oFont,100)
	Else
		oPrint:Say(nLinha, 1800," : " + Alltrim(Str(cAlias->CJ_ZZDIAEN)) + " dias teis aps o fechamento.",oFont5:oFont,100)
	Endif
	nLinha += 50
	/*
	oPrint:Say(nLinha, nColuna, "E-mail"								,oFont3:oFont,100)
	oPrint:Say(nLinha, nColuna + 0190, ": " + cAlias->A1_EMAIL			,oFont5:oFont,100)
	oPrint:Say(nLinha, 1500,"Contato" 			,oFont3:oFont,100)
	oPrint:Say(nLinha, 1640,": " + cAlias->A1_CONTATO,oFont5:oFont,100)
	nLinha += 50
	*/
	oPrint:Say(nLinha, nColuna, "Endereo"								,oFont3:oFont,100)
	oPrint:Say(nLinha, nColuna + 0190, ": " + cAlias->A1_END			,oFont5:oFont,100)
	oPrint:Say(nLinha, 1500,"Bairro" 			,oFont3:oFont,100)
	oPrint:Say(nLinha, 1640,": " + cAlias->A1_BAIRRO,oFont5:oFont,100)
	nLinha += 50
	oPrint:Say(nLinha, nColuna, "Cidade"								,oFont3:oFont,100)
	oPrint:Say(nLinha, nColuna + 0190, ": " + cAlias->A1_MUN	   		,oFont5:oFont,100)
	oPrint:Say(nLinha, 1500,"CEP" 				,oFont3:oFont,100)
	oPrint:Say(nLinha, 1640,": " + LEFT(cAlias->A1_CEP,5) + "-" + RIGHT(cAlias->A1_CEP,3),oFont5:oFont,100)
	nLinha += 50
	/*
	oPrint:Say(nLinha, nColuna, "TEL",oFont3:oFont,100)
	oPrint:Say(nLinha, nColuna + 0190, ": (" + cAlias->A1_DDD + ") " + LEFT(cAlias->A1_TEL,4) + "-" + SUBSTR(cAlias->A1_TEL,5,8),oFont5:oFont,100)
	*/
	oPrint:Say(nLinha, nColuna,"Estado",oFont3:oFont,100)
	oPrint:Say(nLinha, nColuna + 0190,": " + cAlias->A1_EST,oFont5:oFont,100)
	oPrint:Say(nLinha, 1500,"Regio" ,oFont3:oFont,100)
	oPrint:Say(nLinha, 1640, ": (Cd. " + cAlias->CJ_ZZREGIA + ") " + Upper(cDescReg) ,oFont5:oFont,100)

	nLinha += 50
	If LEN(ALLTRIM(cAlias->A1_CGC)) > 11 
		oPrint:Say(nLinha, nColuna, "CNPJ",oFont3:oFont,100)
		oPrint:Say(nLinha, nColuna + 0190, ": " + AllTrim(Transform(cAlias->A1_CGC,"@R 99.999.999/9999-99")),oFont5:oFont,100)
	ELSE
		oPrint:Say(nLinha, nColuna, "CPF",oFont3:oFont,100)
		oPrint:Say(nLinha, nColuna + 0190, ": " + AllTrim(Transform(cAlias->A1_CGC,"@R 999.999.999-99")),oFont5:oFont,100)
	ENDIF
	oPrint:Say(nLinha, 1500,"I.E.",oFont3:oFont,100)
	If LEN(ALLTRIM(cAlias->A1_INSCR)) > 6
		oPrint:Say(nLinha, 1640,": " + AllTrim(Transform(cAlias->A1_INSCR,"@R 999.999.999.999")),oFont5:oFont,100)
	Else
		oPrint:Say(nLinha, 1640,": " + AllTrim(cAlias->A1_INSCR),oFont5:oFont,100)
	EndIf
	nLinha += 50

	
	oPrint:Say(nLinha, nColuna, "Prospect" 												,oFont3:oFont,100)
	oPrint:Say(nLinha, nColuna + 0190, ": " + cAlias->US_COD + " - " + cAlias->US_NOME	,oFont5:oFont,100)
	If LEN(ALLTRIM(cAlias->US_CGC)) > 11
		oPrint:Say(nLinha, 1500,"CNPJ Prospect",oFont3:oFont,100)
		oPrint:Say(nLinha,1700," : " + AllTrim(Transform(cAlias->US_CGC,"@R 99.999.999/9999-99")),oFont5:oFont,100)
	Else
		oPrint:Say(nLinha,1500,"CPF Prospect",oFont3:oFont,100)
		oPrint:Say(nLinha,1700," : " + AllTrim(Transform(cAlias->US_CGC,"@R 999.999.999-99")),oFont5:oFont,100)
	EndIf
	nLinha += 30


Return Nil

//============================================================================================================================================================================
Static Function IMPPRO(nLinha, nColuna, cOrc, nCount, nQtdPag)
//============================================================================================================================================================================
	Local nTotal    := 0 	// Controle do Valor Total do ORCAMENTO 
	Local nVTIpi    := 0 	// Controle do Valor Total do ORCAMENTO com IPI
	Local nVtotalST := 0
	Local nPag      := 1
	Local nCont     := 1
	Local cInfoAdic := ""
	Local nLinha2	:= 40
	Local nLinRod 	:= 3110
	//Local nColBoxBkp 	:= nColFim

	

	// Controle da posio das Coluna
	Local nColItem 	:= 0120
	Local nColProd  := 0370
	Local nColDesc 	:= 1170
	Local nColNcm	:= 1300
	Local nColUM   	:= 1360
	Local nColQtd  	:= 1450
	Local nColPrc  	:= 1630
	Local nColTot  	:= 1760
	Local nColIPI  	:= 1850
	Local nColICMS 	:= 1950
	Local nColVICM	:= 2100
	Local nColStd	:= 2250
	
	
	Local nItemD  	:= 0045
	Local nProdD   	:= nColItem + 15
	Local nDescD 	:= nColProd + 15
	Local nNcmD		:= nColDesc + 35
	Local nUMD   	:= nColNcm  + 10
	Local nQtdD  	:= nColUM 	+ 10
	Local nPrcD  	:= nColQtd 	+ 15
	Local nTotD  	:= nColPrc 	+ 20
	Local nIPID  	:= nColTot 	+ 15
	Local nICMSD 	:= nColIPI 	+ 10
	Local nICMS		:= nColICMS	+ 10
	Local nStD   	:= nColVICM + 15
	Local nISS		:= nColStd  + 15
	Local nBICMS 	:= 0		//--- Base ICMS
	Local nAICMS	:= 0 		//--- Aliq. ICMS
	Local nVICMS 	:= 0 		//--- Valor ICMS
	Local nBSICMS 	:= 0 		//--- Base ICMS Solidrio
	Local nASICMS 	:= 0 		//--- Aliq. ICMS Solidrio
	Local nVSICMS 	:= 0 		//--- Valor ICMS Solidrio
	Local nBIPI 	:= 0 		//--- Base IPI
	Local nAIPI 	:= 0 		//--- Aliq. IPI
	Local nVIPI 	:= 0 		//--- Valor IPI
	Local nBCOF 	:= 0 		//--- Base COFINS
	Local nACOF 	:= 0 		//--- Aliq. COFINS
	Local nVCOF 	:= 0 		//--- Valor COFINS
	Local nBPIS 	:= 0 		//--- Base PIS
	Local nAPIS 	:= 0 		//--- Aliq. PIS
	Local nVPIS 	:= 0 		//--- Valor PIS
	Local cSimb     := Alltrim(GetMv("MV_SIMB1")) // Simbolo, Descricao Singular e Plural da Moeda 1
	Private nTpag   := 0

		/*Ajuste realizado para ser impresso de aliquotas de acordo com a aliquota atual do oramento.
		  Por Matheus Monteiro em:13/09/2022
		*/

		nAICMS	+= cAlias->CK_ZICM 			//--- Aliq. ICMS	
		nASICMS += cAlias->CK_ZICMSOL 		//--- Aliq. ICMS Solidrio	
		nAIPI 	+= cAlias->CK_ZIPI 			//--- Aliq. IPI
		nACOF 	+= cAlias->CK_ZCOF 			//--- Aliq. COFINS
		nAPIS 	+= cAlias->CK_ZPIS 			//--- Aliq. PIS

	nColuna:= 0


	/*---------------------------------------------------------------------*
	| Box, Linhas Verticais e Dados do Cabecalho de ORCAMENTO.                |
	*---------------------------------------------------------------------*/
	oPrint:Box(nLinha, nColuna + 0040, nLinha + 0050, nColuna + 2360)


	//Linhas Verticais
	oPrint:Line(nLinha,nColuna + nColItem	,nLinha + 0050,nColuna + nColItem	) // Coluna Item
	oPrint:Line(nLinha,nColuna + nColProd	,nLinha + 0050,nColuna + nColProd	) // Coluna Produto
	oPrint:Line(nLinha,nColuna + nColDesc	,nLinha + 0050,nColuna + nColDesc	) // Coluna Descrio
	oPrint:Line(nLinha,nColuna + nColNcm	,nLinha + 0050,nColuna + nColNcm	) // Coluna NCM
	oPrint:Line(nLinha,nColuna + nColUM		,nLinha + 0050,nColuna + nColUM		) // Coluna UM
	oPrint:Line(nLinha,nColuna + nColQtd	,nLinha + 0050,nColuna + nColQtd	) // Coluna Qtd
	oPrint:Line(nLinha,nColuna + nColPrc	,nLinha + 0050,nColuna + nColPrc	) // Coluna Prc Unit.
	oPrint:Line(nLinha,nColuna + nColTot	,nLinha + 0050,nColuna + nColTot	) // Coluna Total
	oPrint:Line(nLinha,nColuna + nColIPI	,nLinha + 0050,nColuna + nColIPI	) // Coluna IPI
	oPrint:Line(nLinha,nColuna + nColICMS	,nLinha + 0050,nColuna + nColICMS	) // Coluna ICMS
	oPrint:Line(nLinha,nColuna + nColVICM	,nLinha + 0050,nColuna + nColVICM	) // Coluna ICMS
	oPrint:Line(nLinha,nColuna + nColStd	,nLinha + 0050,nColuna + nColStd	) // Coluna ISS

	oPrint:Say(nLinha + 030,nColuna + nItemD 	,"ITEM" 		,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nProdD 	,"PRODUTO" 		,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nDescD 	,"DESCRIO" 	,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nNcmD 	,"NCM" 			,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nUMD 		,"UM" 			,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nQtdD 	,"QTD." 		,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nPrcD 	,"PRC UNIT." 	,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nTotD 	,"TOTAL" 		,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nIPID 	,"IPI%" 		,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nICMSD 	,"ICMS%" 		,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nICMS		,"VLR ICMS" 	,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nStD 		,"VLR ST" 		,oFont3:oFont,100)
	oPrint:Say(nLinha + 030,nColuna + nISS		,"ISS%" 		,oFont3:oFont,100)
	
	
	nLinha := nLinha + 0050


		nLinRod := 3110

		//Linha Separatria
		oPrint:Line(nLinRod, nColIni,nLinRod, nColFim)
		nLinRod += 25
			
		//Dados da Esquerda
		cTexto := "Oramento: " + cOrc + "    |    " + dToC(Date()) + "     " + cHoraEx + "  " + UsrRetName(RetCodUsr())
		oPrint:Say(nLinRod, nColIni, cTexto, oFont7:oFont, 250, 07,	, nEsquerda, )

		//Direita
		cTexto := "Pgina " + str(nPag) + " / " + AllTrim(nQtdPag)
		oPrint:Say(nLinRod, nColFim-500, cTexto, oFont7:oFont, 150, 07, , nDireita, )

		//nLinha += 50
		oPrint:EndPage()

		


	While cAlias->(!Eof()) .AND. cAlias->CJ_NUM == cOrc

		If nLinha >= 2900
			//Linhas Horizontais  -  FIM ORCAMENTO
			oPrint:Box(nLinha, nColuna + 0040, nLinha + 0050, nColuna + 2360)

			nColuna := nColunaBkp

			//IMPROD(@nLinha, @nColuna, NPag, nTotal)
			IMPCAB(@nLinha, @nColuna, cOrc, cEmissao)

			nPag++

			nColuna := nColunaBkp
			
			oPrint:Box(nLinha,0042, nLinha +0050, nColFim)
		
			//Linhas Verticais
			oPrint:Line(nLinha,nColuna + nColItem	,nLinha		+ 050,nColuna + nColItem) 	// Coluna Item
			oPrint:Line(nLinha,nColuna + nColProd	,nLinha	    + 050,nColuna + nColProd)	// Coluna Produto
			oPrint:Line(nLinha,nColuna + nColDesc	,nLinha	    + 050,nColuna + nColDesc) 	// Coluna Descrio
			oPrint:Line(nLinha,nColuna + nColNcm	,nLinha	    + 050,nColuna + nColNcm) 	// Coluna NCM
			oPrint:Line(nLinha,nColuna + nColUM		,nLinha		+ 050,nColuna + nColUM) 	// Coluna UM
			oPrint:Line(nLinha,nColuna + nColQtd	,nLinha		+ 050,nColuna + nColQtd) 	// Coluna Qtd
			oPrint:Line(nLinha,nColuna + nColPrc	,nLinha 	+ 050,nColuna + nColPrc) 	// Coluna Prc Unit.
			oPrint:Line(nLinha,nColuna + nColTot	,nLinha 	+ 050,nColuna + nColTot) 	// Coluna Total
			oPrint:Line(nLinha,nColuna + nColIPI	,nLinha 	+ 050,nColuna + nColIPI) 	// Coluna IPI
			oPrint:Line(nLinha,nColuna + nColICMS	,nLinha 	+ 050,nColuna + nColICMS) 	// Coluna ICMS
			oPrint:Line(nLinha,nColuna + nColVICM	,nLinha 	+ 050,nColuna + nColVICM) 	// Coluna ICMS
			oPrint:Line(nLinha,nColuna + nColStd	,nLinha 	+ 050,nColuna + nColStd) 	// Coluna ICMS

			oPrint:Say(nLinha + 030,nColuna + nItemD 	,"ITEM"		,oFont3:oFont,100)
			oPrint:Say(nLinha +	030,nColuna + nProdD  	,"PRODUTO"	,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nDescD	,"DESCRIO",oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nNcmD		,"NCM"		,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nUMD		,"UM"		,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nQtdD		,"QTD."		,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nPrcD		,"PRC UNIT.",oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nTotD		,"TOTAL"	,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nIPID		,"IPI%"	   	,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nICMSD	,"ICMS%"	   	,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nICMS		,"VLR ICMS"	,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nStD		,"VLR ST"  ,oFont3:oFont,100)
			oPrint:Say(nLinha + 030,nColuna + nISS		,"ISS%"  	,oFont3:oFont,100)
		
			nLinha := nLinha + 050

			nLinRod := 3110

		   //Linha Separatria
			oPrint:Line(nLinRod, nColIni,nLinRod, nColFim)
			nLinRod += 25
			
			//Dados da Esquerda
			cTexto := "Oramento: " + cOrc + "    |    " + dToC(Date()) + "     " + cHoraEx + "  " + UsrRetName(RetCodUsr())
			oPrint:Say(nLinRod, nColIni, cTexto, oFont7:oFont, 250, 07, , nEsquerda, )

			//Direita
			cTexto := "Pgina " + str(nPag) + " / " + AllTrim(nQtdPag)
			oPrint:Say(nLinRod, nColFim-500, cTexto, oFont7:oFont, 150, 07, , nDireita, )

			oPrint:EndPage()

		EndIf
		/*Dados dos Produtos sem as informaes adicionais
		*/
		oPrint:Line(nLinha,nColuna + 0040		,nLinha + 060,nColuna + 0040)
		oPrint:Line(nLinha,nColuna + 2360		,nLinha + 060,nColuna + 2360)
		oPrint:Line(nLinha,nColuna + nColItem	,nLinha + 060,nColuna + nColItem) 	// Item
		oPrint:Line(nLinha,nColuna + nColProd	,nLinha + 060,nColuna + nColProd) 	// Produto
		oPrint:Line(nLinha,nColuna + nColDesc	,nLinha + 060,nColuna + nColDesc) 	// Descrio
		oPrint:Line(nLinha,nColuna + nColNcm	,nLinha + 060,nColuna + nColNcm) 	// NCM
		oPrint:Line(nLinha,nColuna + nColUM		,nLinha + 060,nColuna + nColUM) 	// UM
		oPrint:Line(nLinha,nColuna + nColQtd	,nLinha + 060,nColuna + nColQtd) 	// Qtd
		oPrint:Line(nLinha,nColuna + nColPrc	,nLinha + 060,nColuna + nColPrc) 	// Coluna Prc Unit.
		oPrint:Line(nLinha,nColuna + nColTot	,nLinha + 060,nColuna + nColTot) 	// Coluna Total
		oPrint:Line(nLinha,nColuna + nColIPI	,nLinha + 060,nColuna + nColIPI) 	// Coluna IPI
		oPrint:Line(nLinha,nColuna + nColICMS	,nLinha	+ 060,nColuna + nColICMS) 	// Coluna ICMS
		oPrint:Line(nLinha,nColuna + nColVICM	,nLinha	+ 060,nColuna + nColVICM) 	// Coluna ICMS
		oPrint:Line(nLinha,nColuna + nColStd	,nLinha	+ 060,nColuna + nColStd) 	// Coluna ICMS ST

		// Impressao dos Campos dos Detalhes dos Produtos
		oPrint:Say(nLinha + 0030, nItemD +20,AllTrim(cAlias->CK_ITEM),oFont8:oFont,100)
		oPrint:Say(nLinha + 0030, nProdD ,AllTrim(cAlias->CK_PRODUTO),oFont8:oFont,100)
	
		If Len(AllTrim(cAlias->CK_PRODUTO)) + Len(AllTrim(cAlias->CK_DESCRI)) > 50
			oPrint:Say(nLinha + 0030, nDescD, SUBSTR(AllTrim(cAlias->CK_DESCRI),1,70-Len(AllTrim(cAlias->CK_PRODUTO))),oFont8:oFont,100)
			nLinha += 0020
			//oPrint:Say(nLinha + 0030, nDescD, SUBSTR(AllTrim(cAlias->CK_DESCRI),1,50-Len(AllTrim(cAlias->CK_PRODUTO))) + " (NCM " + AllTrim(Transform(cAlias->B1_POSIPI, "@R 9999.99.99")) + ")" ,oFont2:oFont,100)
			oPrint:Say(nLinha + 0030,nDescD, SUBSTR(AllTrim(cAlias->CK_DESCRI),65,70-Len(AllTrim(cAlias->CK_PRODUTO))),oFont8:oFont,100)
			oPrint:Say(nLinha + 0010, nNcmD-15,AllTrim(cAlias->B1_POSIPI),oFont8:oFont,100)  
		Else
			oPrint:Say(nLinha + 0030, nDescD, AllTrim(cAlias->CK_DESCRI),oFont8:oFont,100)
			nLinha += 0020
			oPrint:Say(nLinha + 0010, nNcmD-15,AllTrim(cAlias->B1_POSIPI),oFont8:oFont,100) 
		EndIf			
			
		oPrint:Say(nLinha + 0010, nUMD, AllTrim(cAlias->CK_UM)													,oFont8:oFont,100)
		oPrint:Say(nLinha + 0010, nQtdD+15, Alltrim(STR(cAlias->CK_QTDVEN))											,oFont8:oFont,100)
		oPrint:Say(nLinha + 0010, nPrcD, Alltrim(Transform(cAlias->CK_PRCVEN, PesqPict('SCK', 'CK_PRCVEN'))) 	,oFont8:oFont,100)
		oPrint:Say(nLinha + 0010, nTotD-10, Alltrim(Transform(cAlias->CK_VALOR, PesqPict('SCK', 'CK_VALOR')))	 	,oFont8:oFont,100)
			
		If cAlias->F4_IPI == "S" .AND. cAlias->B1_IPI > 0
			oPrint:Say(nLinha + 0010, nIPID, Alltrim(STR(cAlias->B1_IPI,5,1))	,oFont8:oFont,100)
			nVTIpi += (((cAlias->CK_VALOR * cAlias->B1_IPI)/100) + cAlias->CK_VALOR)
		Else
			oPrint:Say(nLinha + 0010, nIPID+15, "0"	,oFont8:oFont,100)
			nVTIpi += cAlias->CK_VALOR
		EndIf
				
		If cAlias->F4_ICM == "S"
			oPrint:Say(nLinha + 0010, nICMSD, AllTrim(Transform(cAlias->CK_ZICM, "@E 99.99")) ,oFont8:oFont,100) //ICM
			oPrint:Say(nLinha + 0010, nICMS, Alltrim(Transform(cAlias->CK_ZVALICM, PesqPict('SCK','CK_ZVALICM'))),oFont8:oFont,100)
		Else
			oPrint:Say(nLinha + 0010, nICMSD+30, "0"	,oFont8:oFont,100) //ICM
			oPrint:Say(nLinha + 0010, nICMS+30,Alltrim(Transform(cAlias->CK_ZVALICM, PesqPict('SCK','CK_ZVALICM'))),oFont8:oFont,100)
		EndIf
			
		oPrint:Say(nLinha + 0010, nStD+05, Alltrim(Transform(cAlias->CK_ZVALSOL, PesqPict('SCK','CK_ZVALSOL'))),oFont8:oFont,100)

		If cAlias->F4_ISS == "S"
			oPrint:Say(nLinha + 0010, nISS+05, AllTrim(Transform(cAlias->B1_ALIQISS, "@E 99.99")) ,oFont8:oFont,100) //ICM
		Else
			oPrint:Say(nLinha + 0010, nISS+15, "0"	,oFont8:oFont,100) //ISS
		EndIf
		

		// Calculo do Valor Total do Oramento de Vendas
		nTotal += cAlias->CK_VALOR

		//Calcula o Valor Total da ST
		nVtotalST += cAlias->CK_ZVALSOL
		nLinha := nLinha + 40

		nBICMS 	+= cAlias->CK_ZBASICM		//--- Base ICMS
		nVICMS 	+= cAlias->CK_ZVALICM 		//--- Valor ICMS
		nBSICMS += cAlias->CK_ZBASSOL 		//--- Base ICMS Solidrio
		nVSICMS += cAlias->CK_ZVALSOL 		//--- Valor ICMS Solidrio
		nBIPI 	+= cAlias->CK_ZBASIPI 		//--- Base IPI
		nVIPI 	+= cAlias->CK_ZVALIPI 		//--- Valor IPI
		nBCOF 	+= cAlias->CK_ZBASCOF 		//--- Base COFINS
		nVCOF 	+= cAlias->CK_ZVALCOF 		//--- Valor COFINS
		nBPIS 	+= cAlias->CK_ZBASPIS 		//--- Base PIS
		nVPIS 	+= cAlias->CK_ZVALPIS 		//--- Valor PIS
	
	
		cInfoAdic 	:= cAlias->CK_ZZINFAD		
		cInfoAdic 	:= Alltrim(cInfoAdic)
		cInfoAdic 	:= Upper(cInfoAdic)
		nIniInfoAdic:= 1
		nLinAux     := nLinha

		While !Empty(cInfoAdic)
			
			oPrint:Line(nLinha,nColuna + 0040		,nLinha + nLinha2,nColuna + 0040)
			oPrint:Line(nLinha,nColuna + 2360		,nLinha + nLinha2,nColuna + 2360)
			oPrint:Line(nLinha,nColuna + nColItem	,nLinha + nLinha2,nColuna + nColItem) 	// Item
			oPrint:Line(nLinha,nColuna + nColProd	,nLinha + nLinha2,nColuna + nColProd) 	// Produto
			oPrint:Line(nLinha,nColuna + nColDesc	,nLinha + nLinha2,nColuna + nColDesc) 	// Descrio
			oPrint:Line(nLinha,nColuna + nColNcm	,nLinha + nLinha2,nColuna + nColNcm) 	// Descrio
			oPrint:Line(nLinha,nColuna + nColUM		,nLinha + nLinha2,nColuna + nColUM) 	// UM
			oPrint:Line(nLinha,nColuna + nColQtd	,nLinha + nLinha2,nColuna + nColQtd) 	// Qtd
			oPrint:Line(nLinha,nColuna + nColPrc	,nLinha + nLinha2,nColuna + nColPrc) 	// Coluna Prc Unit.
			oPrint:Line(nLinha,nColuna + nColTot	,nLinha + nLinha2,nColuna + nColTot) 	// Coluna Total
			oPrint:Line(nLinha,nColuna + nColIPI	,nLinha + nLinha2,nColuna + nColIPI) 	// Coluna IPI
			oPrint:Line(nLinha,nColuna + nColICMS	,nLinha	+ nLinha2,nColuna + nColICMS) 	// Coluna ICMS
			oPrint:Line(nLinha,nColuna + nColVICM	,nLinha	+ nLinha2,nColuna + nColVICM) 	// Coluna ICMS
			oPrint:Line(nLinha,nColuna + nColStd	,nLinha	+ nLinha2,nColuna + nColStd) 	// Coluna ISS
		
			oPrint:Say(nLinAux + 0025, nDescD,Substr(cInfoAdic,1,55) ,oFont8:oFont,100)
			nLinAux	   	+= 20
			nLinha      += 40
			nIniInfoAdic+= 40

			cInfoAdic := Substr(cInfoAdic,65,Len(cInfoAdic))		

		Enddo

		oPrint:Line(nLinha, nColuna+40,nLinha, nColFim)	
	
	//Incrementa Contador da Quantidade de Itens no Oramento de Vendas
	nCont ++

	//Se o arquivo chegou ao fim, imprime rodape.
		IF nCont > nCount

			If SCJ->CJ_MOEDA > 1 .And. SCJ->CJ_MOEDA <= 5
				cSimb := Alltrim(GetMv("MV_SIMB" + Str(cAlias->CJ_MOEDA, 1)))
			Endif
			
			nTotal := nTotal + cAlias->CJ_FRETE + cAlias->CJ_DESPESA

			//Linhas Horizontais  -  FIM ORCAMENTO
			//oPrint:Line(nLinha,nColuna + 0040,nLinha,nColuna + 2360)

			oPrint:Box(nLinha, nColuna + 0040, nLinha + 0050, nColuna + 2360)
						
					

					oPrint:Say(nLinha, 0600, "Valor Frete"		,oFont3:oFont,100)
					oPrint:Say(nLinha, 1000, cSimb +" "+ Alltrim(Transform(cAlias->CJ_FRETE, PesqPict('SCJ', 'CJ_FRETE')))	,oFont3:oFont,100)
					oPrint:Say(nLinha, 1330, "Valor Total",oFont3:oFont,100)
					oPrint:Say(nLinha, 1700, cSimb +" "+ Alltrim(Transform(nTotal, PesqPict('SCK', 'CK_VALOR')))	,oFont3:oFont,100)
					nLinha += 30

					oPrint:Say(nLinha, 0600, "Valor Despesa"		,oFont3:oFont,100)
					oPrint:Say(nLinha, 1000, cSimb +" "+ Alltrim(Transform(cAlias->CJ_DESPESA, PesqPict('SCJ', 'CJ_DESPESA')))	,oFont3:oFont,100)	

					oPrint:Say(nLinha, 1330, "Total + IPI + ST"		,oFont3:oFont,100)
					oPrint:Say(nLinha, 1700, cSimb +" "+ Alltrim(Transform(nVTIpi+nVtotalST,"@E 9,999,999.99"))	,oFont3:oFont,100)
									
					nLinha += 30			

					nColImp := 400
					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+80, "Base ICMS"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nBICMS,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 300

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+200)
					oPrint:Say(nLinha+30, nColImp+20, "Aliq. ICMS"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nAICMS,"@E 99.99")			,oFont3:oFont,100)
					nColImp += 200

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+80, "Valor ICMS"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nVICMS,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 350

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+60, "Base ICMS ST"						,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nBSICMS,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 300

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+40, "Aliq. ICMS ST"						,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+40, Transform(nASICMS,"@E 99.99")			,oFont3:oFont,100)
					nColImp += 300

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+30, "Valor ICMS ST"						,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+25, Transform(nVSICMS,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 300

					nColImp := 400
					nLinha 	+= 130
					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+80, "Base IPI"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nBIPI,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 300

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+200)
					oPrint:Say(nLinha+30, nColImp+20, "Aliq. IPI"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nAIPI,"@E 99.99")			,oFont3:oFont,100)
					nColImp += 200

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+80, "Valor IPI"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nVIPI,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 350

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+70, "Base COFINS"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nBCOF,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 300

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+40, "Aliq. COFINS"						,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+40, Transform(nACOF,"@E 99.99")			,oFont3:oFont,100)
					nColImp += 300

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+50, "Valor COFINS"						,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nVCOF,"@E 9,999,999.99")	,oFont3:oFont,100)

					nColImp := 850
					nLinha 	+= 130

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+80, "Base PIS"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nBPIS,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 300

					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+200)
					oPrint:Say(nLinha+30, nColImp+20, "Aliq. PIS"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nAPIS,"@E 99.99")			,oFont3:oFont,100)
					nColImp += 200


					oPrint:Box(nLinha, nColImp, nLinha + 50, nColImp+300)
					oPrint:Say(nLinha+30, nColImp+80, "Valor PIS"							,oFont3:oFont,100)
					oPrint:Box(nLinha+50, nColImp, nLinha + 100, nColImp+300)
					oPrint:Say(nLinha+80, nColImp+20, Transform(nVPIS,"@E 9,999,999.99")	,oFont3:oFont,100)
					nColImp += 300		
					// Funcao de Impressao do Rodape. Parametro: Numero da linha atual
					IMPROD(@nLinha, @nColuna, NPag, nTotal)	
			EndIf
	

	cAlias->(dbskip())	

	EndDo

Return Nil

Static Function IMPROD(nLinha, nColuna, nPag, nTotal)

	Local aOBS    	:= MemoToA(AllTrim(cAlias->CJ_ZZOBSOR), 100)
	Local nOBS	  	:= 0
	Local cMoeda    := Alltrim(GetMv("MV_MOEDA1")) // Moeda 1
	Local cTexto 	:= ""

	nColuna := 0

	If SCJ->CJ_MOEDA > 1 .And. SCJ->CJ_MOEDA <= 5
		cMoeda := Alltrim(GetMv("MV_MOEDA" + Str(cAlias->CJ_MOEDA, 1)))
	Endif

	If nLinha >= 1900
		oPrint:EndPage()
		IMPCAB(@nLinha, @nColuna, cOrc, cEmissao)
	Endif

	nLinha := 1900
	// Box Informaes Gerais
	oPrint:Box(nLinha, 0010, nLinha + 300, nColFim)
	nLinha += 30

	// cTitulo Centralizado
	oPrint:Say(nLinha, 800,"- I N F O R M A   E S    G E R A I S -" ,oFont1:oFont,100,,,nCenter)
	nLinha += 30

	// Textos Posicionados  Esquerda
	oPrint:Say(nLinha, 060, "Forma de Pagamento" ,oFont3:oFont,100)
	oPrint:Say(nLinha, 450, ": (Cd. "+cAlias->CJ_CONDPAG + ") " + Upper(cAlias->E4_DESCRI) ,oFont5:oFont,100)
	oPrint:Say(nLinha, 1300,"Moeda" ,oFont3:oFont,100)
	oPrint:Say(nLinha, 1600, ": "+cMoeda ,oFont5:oFont,100)
	nLinha += 50
	oPrint:Say(nLinha, 060, "Tipo do Frete" ,oFont3:oFont,100)
	oPrint:Say(nLinha, 450, ":"+cAlias->CJ_TPFRETE ,oFont5:oFont,100)
	oPrint:Say(nLinha, 1300,"Validade" ,oFont3:oFont,100)
	oPrint:Say(nLinha, 1600, ": "+DTOC(cAlias->CJ_VALIDA) ,oFont5:oFont,100)
	nLinha += 50
	oPrint:Say(nLinha, 060, "Contato" ,oFont3:oFont,100)
	oPrint:Say(nLinha, 450, ": "+ Upper(Alltrim(cAlias->CJ_ZZCONT)) ,oFont5:oFont,100)
	oPrint:Say(nLinha, 1300, "Tel. Contato" ,oFont3:oFont,100)

	If Empty(Alltrim(cAlias->CJ_ZZTEL))
		oPrint:Say(nLinha, 1600, ": (" + cAlias->A1_DDD + ") " + LEFT(cAlias->A1_TEL,5) + "-" + SUBSTR(cAlias->A1_TEL,6,9),oFont5:oFont,100)
	Else
		oPrint:Say(nLinha, 1600, ": (" + cAlias->A1_DDD + ") " + LEFT(cAlias->CJ_ZZTEL,5) + "-" + SUBSTR(cAlias->CJ_ZZTEL,6,9),oFont5:oFont,100)
		
	Endif

	nLinha += 50
	oPrint:Say(nLinha, 060,"E-mail Contato" ,oFont3:oFont,100)
	oPrint:Say(nLinha, 450, ": "+AllTrim(cAlias->CJ_ZZEMAIL) ,oFont5:oFont,100)
	nLinha += 50
	oPrint:Say(nLinha, 0060, "Vendedor" ,oFont3:oFont,100)
	oPrint:Say(nLinha, 0450, ": (Cd. " + Alltrim(cAlias->CJ_ZZVEND) + ") " + Upper(Alltrim(cAlias->A3_NOME)) +" - E-mail: "+Alltrim(cAlias->A3_EMAIL) ,oFont5:oFont,100)
	nLinha += 30

	// Box para Observaes
	oPrint:Box(nLinha, 010, nLinha + 900, nColFim)
	nLinha += 50
	oPrint:Say(nLinha, 060,"O B S E R V A   E S:" ,oFont1:oFont,100,,,2)
	nLinha += 50

	if len(aOBS) > 0
		for nOBS := 1 to len(aOBS)
			oPrint:Say (nLinha, 060, Upper(aOBS[nOBS]),oFont5:oFont)
			nLinha += 45
		next nOBS
	endif

	nLinRod := 3110

	//Linha Separatria
	oPrint:Line(nLinRod, nColIni,nLinRod, nColFim)
	nLinRod += 25
	
	//Dados da Esquerda
	cTexto := "Oramento: " + cOrc + "    |    " + dToC(Date()) + "     " + cHoraEx + "  " + UsrRetName(RetCodUsr())
	oPrint:Say(nLinRod, nColIni, cTexto, oFont7:oFont, 250, 07, , nEsquerda, )

	//Direita
	cTexto := "Pgina " + str(nPag) + " / " + AllTrim(nQtdPag)
	oPrint:Say(nLinRod, nColFim-500, cTexto, oFont7:oFont, 150, 07, , nDireita, )

	//nLinha += 50
	oPrint:EndPage()
	
Return Nil


Static Function ValidPerg(cPerg)

	Local _sAlias := Alias()
	Local aRegs := {}
	Local i,j

	dbSelectArea("SX1")
	dbSetOrder(1)
	cPerg := PADR(cPerg,Len(SX1->X1_GRUPO))

	// Grupo/Ordem/Pergunta/Variavel/Tipo/Tamanho/Decimal/Presel/GSC/Valid/Var01/Def01/Cnt01/Var02/Def02/Cnt02/Var03/Def03/Cnt03/Var04/Def04/Cnt04/Var05/Def05/Cnt05
	aAdd(aRegs, {cPerg, "01", "Oramento de "   ,"" ,"" ,"mv_ch1", "C", 12, 0, 0, "G", "", "mv_par01", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "SCJ"})
	aAdd(aRegs, {cPerg, "02", "Oramento at "  ,"" ,"" ,"mv_ch2", "C", 12, 0, 0, "G", "", "mv_par02", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "SCJ"})
	aAdd(aRegs, {cPerg, "03", "Data de "        ,"" ,"" ,"mv_ch3", "D", 08, 0, 0, "G", "", "mv_par03", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""})
	aAdd(aRegs, {cPerg, "04", "Data at "       ,"" ,"" ,"mv_ch4", "D", 08, 0, 0, "G", "", "mv_par04", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""})

	For i:=1 to Len(aRegs)
		If !dbSeek(cPerg+aRegs[i,2])
			RecLock("SX1",.T.)
			For j:=1 to FCount()
				If j <= Len(aRegs[i])
					FieldPut(j,aRegs[i,j])
				Endif
			Next
			MsUnlock()
		Endif
	Next
	dbSelectArea(_sAlias)

Return


/*
Static Function ConvMemo(cObs, nTam)

	Local aObs 		:= {}
	Local nAuxTam   := nTam
	local lRet		:= .F.

	aObs :=StrTokArr(cTexto,Chr(13))

	While Len(cObs) > 0
		while lRet == .F.
			if (SubStr(alltrim(cObs), nTam, 1) == CHR(10) .or. SubStr(alltrim(cObs), nTam, 1) == " " .or. SubStr(alltrim(cObs), nTam, 1) == "") .and. !lRet
				aAdd(aObs, replace(SubStr(alltrim(cObs), 1, nTam),CHR(10)," "))
				lRet := .T.
			else
				nTam := nTam -1
			endif
		enddo
		cObs := SubStr(cObs, nTam+1, Len(cObs))
		nTam := nAuxTam
		lRet := .F.
	Enddo
Return aObs


*/

Static Function MemoToA(cTexto, nMaxCol, cQuebra, lTiraBra)
    Local aArea     := GetArea()
    Local aTexto    := {}
    Local aAux      := {}
    Local nAtu      := 0
    Default cTexto  := ''
    Default nMaxCol := 80
    Default cQuebra := ';'
    Default lTiraBra:= .T.
 
    //Quebrando o Array, conforme -Enter-
    aAux:= StrTokArr(cTexto,Chr(13))
     
    //Correndo o Array e retirando o tabulamento
    For nAtu:=1 TO Len(aAux)
        aAux[nAtu]:=StrTran(aAux[nAtu],Chr(10),'')
    Next
     
    //Correndo as linhas quebradas
    For nAtu:=1 To Len(aAux)
     
        //Se o tamanho de Texto, for maior que o nmero de colunas
        If (Len(aAux[nAtu]) > nMaxCol)
         
            //Enquanto o Tamanho for Maior
            While (Len(aAux[nAtu]) > nMaxCol)
                //Pegando a quebra conforme texto por parmetro
                nUltPos:=Rat(cQuebra,SubStr(aAux[nAtu],1,nMaxCol))
                 
                //Caso no tenha, a ltima posio ser o ltimo espao em branco encontrado
                If nUltPos == 0
                    nUltPos:=Rat(' ',SubStr(aAux[nAtu],1,nMaxCol))
                EndIf
                 
                //Se no encontrar espao em branco, a ltima posio ser a coluna mxima
                If(nUltPos==0)
                    nUltPos:=nMaxCol
                EndIf
                 
                //Adicionando Parte da Sring (de 1 at a lima posio vlida)
                aAdd(aTexto,SubStr(aAux[nAtu],1,nUltPos))
                 
                //Quebrando o resto da String
                aAux[nAtu] := SubStr(aAux[nAtu], nUltPos+1, Len(aAux[nAtu]))
            EndDo
             
            //Adicionando o que sobrou
            aAdd(aTexto,aAux[nAtu])
        Else
            //Se for menor que o Mximo de colunas, adiciona o texto
            aAdd(aTexto,aAux[nAtu])
        EndIf
    Next
     
    //Se for para tirar os brancos
    If lTiraBra
        //Percorrendo as linhas do texto e aplica o AllTrim
        For nAtu:=1 To Len(aTexto)
            aTexto[nAtu] := Alltrim(aTexto[nAtu])
        Next
    EndIf
     
    RestArea(aArea)
Return aTexto

